<id>
Glow, Shadow, Undo and Redo for YaBB 2.1
</id>

<version>
0.6 beta
</version>

<mod info>

- adds Undo and Redo buttons to post reply page
- adds new Glow and Shadow functions
- Glow and Shadow now supported in Mozilla/Netscape, Opera...

Instructions:

- If using BoardMod copy ubbc.js from "htdocs/yabbfiles" to "cgi-bin/yabb2/Sources" before applying the mod.

- Apply this mod.

- Upload (in ASCII mode):

     cgi-bin/yabb2/Admin/ModList.pl
     cgi-bin/yabb2/Languages/English/Main.lng
     cgi-bin/yabb2/Sources/Post.pl
     cgi-bin/yabb2/Sources/YaBBC.pl
     public_html/yabbfiles/ubbc.js

- Upload (in binary mode):

     public_html/yabbfiles/Templates/Forum/default/*.gif

</mod info>

<author>
Carsten
</author>


<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$glow_shadow_undo_redo_mod = "Glow_Shadow_Undo_Redo_4_YaBB21|Carsten|This mod adds Undo and Redo buttons to post reply page and new Glow and Shadow functions. Glow and Shadow now supported in Mozilla/Netscape, Opera...|0.6 beta|08/26/06";
	push (@installed_mods, "$glow_shadow_undo_redo_mod");

</add before>


<edit file>
Languages/English/Main.lng
</edit file>

<search for>
'418' => "Notification",
</search for>

<add after>
'442' => "Glow",
'443' => "Shadow",
'444' => "Undo",
'445' => "Redo",
</add after>


<edit file>
Sources/Post.pl
</edit file>

<search for>
		<div style="width: 484px; clear: both;">
		<div style="width: 391px; float:left;">
</search for>

<replace>
		<div style="width: 530px; clear: both;">
		<div style="width: 437px; float:left;">
</replace>

<search for>
          document.write("<img src='$defaultimagesdir/timestamp.gif' onclick='timestamp($date);' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'245'}' title='$post_txt{'245'}' border='0' /><br />");
</search for>

<replace>
          document.write("<img src='$defaultimagesdir/timestamp.gif' onclick='timestamp($date);' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'245'}' title='$post_txt{'245'}' border='0' />");
          document.write("<img src='$defaultimagesdir/undo.gif' id='undo' onclick='UndoRedo(this.id);' "+HAND+" align='top' width='23' height='22' alt='$maintxt{'444'}' title='$maintxt{'444'}' border='0' />");
          document.write("<img src='$defaultimagesdir/redo.gif' id='redo' onclick='UndoRedo(this.id);' "+HAND+" align='top' width='23' height='22' alt='$maintxt{'445'}' title='$maintxt{'445'}' border='0' /><br />");
</replace>

<search for>
          document.write("<img src='$defaultimagesdir/highlight.gif' onclick='highlight();' "+HAND+" align='top' width='23' height='22' alt='$post_txt{'246'}' title='$post_txt{'246'}' border='0' /></b>");
</search for>

<add after>
          document.write("<img src='$imagesdir/glow.gif' onclick='glow();' "+HAND+" align='top' width='23' height='22' alt='$maintxt{'442'}' title='$maintxt{'442'}' border='0' />");
          document.write("<img src='$imagesdir/shadow.gif' onclick='shadow();' "+HAND+" align='top' width='23' height='22' alt='$maintxt{'443'}' title='$maintxt{'443'}' border='0' />");
</add after>

<search for>
        <textarea name="message" id="message" rows="8" cols="70" style="height: 166px; width: $pwidth%; font-family: Verdana; font-size: 11px; padding: 5px; margin: 0px; visibility: visible;" onclick="javascript:storeCaret(this);" onkeyup="javascript:storeCaret(this);" onchange="javascript:storeCaret(this);" tabindex="4">$message</textarea>
</search for>

<replace>
        <textarea name="message" id="message" rows="8" cols="70" style="height: 166px; width: $pwidth%; font-family: Verdana; font-size: 11px; padding: 5px; margin: 0px; visibility: visible;" onclick="javascript:storeCaret(this);" onkeyup="javascript:storeCaret(this); storeKeypressed();" onchange="javascript:storeCaret(this);" tabindex="4">$message</textarea>
        <script language="JavaScript1.2" type="text/javascript">
	<!--
	storeKeypressed();
	//-->
	</script>
</replace>


<edit file>
Sources/YaBBC.pl
</edit file>

<search for>
sub DoUBBC {
</search for>

<add before>
sub gradient {
	$hex2 = $_[0];
	$steps = $_[1];
	if($steps < 2) { $steps=2 }
	if($steps > 7) { $steps = 7 }
	$difdiv = $steps;
	$steps++;
	my(@tocol, @color, @color1, @diff);
	$glowColors = "";
	$tocol[0]=sprintf("%d", hex(substr($hex2,1,2)));
	$tocol[1]=sprintf("%d", hex(substr($hex2,3,2)));
	$tocol[2]=sprintf("%d", hex(substr($hex2,5,2)));
	for($i=0;$i<3;$i++) {
		$diff[$i] = 255 - $tocol[$i];
		if($diff[$i] == 0) { $diff[$i] = 1; }
		$diff[$i] = sprintf("%d", ($diff[$i] / $difdiv));
		$color[$i] = 255;
		$color1[$i] = 0;
	}
	for($i=0;$i<$steps;$i++) {
		if($i > 0) { $glowColors .= qq~#~; }
		for($x=0;$x<3;$x++) {
			if($color[$x] > 255) { $color[$x] = 255; }
			if($color[$x] < 0) { $color[$x] = 0; }
			$color1[$x] = sprintf("%02X", $color[$x]);
			if($i > 0) { $glowColors .= "$color1[$x]"; }
			$color[$x] -= $diff[$x];
		}
		if($i > 0) { $glowColors .= qq~|~; }
	}
	$glowColors = substr($glowColors, 0, -1);
	return $glowColors;
}

sub convColor {
	$gloColor = $_[0];
	$gloDeep = $_[1];
	$gloColors = "";
	$gloColor =~ s~Black~\#000000~i;
	$gloColor =~ s~Gray~\#808080~i;
	$gloColor =~ s~Red~\#FF0000~i;
	$gloColor =~ s~Yellow~\#FFFF00~i;
	$gloColor =~ s~Pink~\#FFC0CB~i;
	$gloColor =~ s~Green~\#008000~i;
	$gloColor =~ s~Orange~\#FFA500~i;
	$gloColor =~ s~Purple~\#800080~i;
	$gloColor =~ s~Blue~\#0000FF~i;
	$gloColor =~ s~Beige~\#F5F5DC~i;
	$gloColor =~ s~Brown~\#A52A2A~i;
	$gloColor =~ s~Teal~\#008080~i;
	$gloColor =~ s~Navy~\#000080~i;
	$gloColor =~ s~Maroon~\#800000~i;
	$gloColor =~ s~LimeGreen~\#32CD32~i;
	$gloColor =~ s~Aqua~\#00FFFF~i;
	$gloColors = &gradient($gloColor, $gloDeep);
	return $gloColors;
}

sub killColor {
	$tmpText = $_[0];
	$tmpText =~ s~\[color=\S+?\](.+?)\[/color\]~$1~eisg;
	$tmpText =~ s~\[bgcolor=\S+?\](.+?)\[/bgcolor\]~$1~eisg;
	$tmpText =~ s~\[black\](.+?)\[/black\]~$1~eisg;
	$tmpText =~ s~\[white\](.+?)\[/white\]~$1~eisg;
	$tmpText =~ s~\[red\](.+?)\[/red\]~$1~eisg;
	$tmpText =~ s~\[green\](.+?)\[/green\]~$1~eisg;
	$tmpText =~ s~\[blue\](.+?)\[/blue\]~$1~eisg;
	return $tmpText;
}

sub makeGlow {
	$theText = $_[0];
	$orgText = $_[0];
	$gldeep = $_[2];
	if($gldeep > 7) { $gldeep = 7 }
	$gloColorstr = &convColor($_[1], $gldeep);
	@glowColor = ();
	@glowColor = split(/\|/, $gloColorstr);
	$gloMarg = $gldeep;
	$theText = &killColor;
	$glowText = "";
	$Deep = $gldeep;
	$tDeep = $Deep;
	$px = "px";
	$glowText = qq~<div style="position: relative; left: $gldeep$px; width: 95%; margin-top: $gloMarg$px; margin-bottom: $gloMarg$px;">~;
	for($i=0;$i<$tDeep;$i++) {
		$gleft = 0 - $Deep; $gright = $Deep;  $gtop = 0; $gbottom = 0;
		for($z=0;$z<$Deep;$z++) {
			$gtop--; $gbottom++;
			$glowText .= qq~<span style="position: absolute; top: $gtop$px; left: $gright$px; float: left; width: 100%; color: $glowColor[$i];">$theText</span>~;
			$glowText .= qq~<span style="position: absolute; top: $gtop$px; left: $gleft$px; float: left; width: 100%; color: $glowColor[$i];">$theText</span>~;
			$glowText .= qq~<span style="position: absolute; top: $gbottom$px; left: $gright$px; float: left; width: 100%; color: $glowColor[$i];">$theText</span>~;
			$glowText .= qq~<span style="position: absolute; top: $gbottom$px; left: $gleft$px; float: left; width: 100%; color: $glowColor[$i];">$theText</span>~;
			$gleft++; $gright--;
		}
		$Deep--;
	}
	$i--;
	$gtop++; $gbottom--;
	$glowText .= qq~<span style="position: absolute; top: $gtop$px; left: $gright$px; float: left; width: 100%; color: $glowColor[$i];">$theText</span>~;
	$glowText .= qq~<span style="position: absolute; top: $gtop$px; left: $gleft$px; float: left; width: 100%; color: $glowColor[$i];">$theText</span>~;
	$glowText .= qq~<span style="position: absolute; top: $gbottom$px; left: $gright$px; float: left; width: 100%; color: $glowColor[$i];">$theText</span>~;
	$glowText .= qq~<span style="position: absolute; top: $gbottom$px; left: $gleft$px; float: left; width: 100%; color: $glowColor[$i];">$theText</span>~;
	$glowText .= qq~<span style="position: absolute; top: 0px; left: 0px; float: left; width: 100%;">$orgText</span>~;
	$glowText .= qq~$theText</div>~;
	return $glowText;
}

sub decode_direction {
	$shadowDir = $_[0];
	$shadowDir =~ s~topright~-3|3|-2|2|-1|1~ig;
	$shadowDir =~ s~bottomright~3|3|2|2|1|1~ig;
	$shadowDir =~ s~bottomleft~3|-3|2|-2|1|-1~ig;
	$shadowDir =~ s~topleft~-3|-3|-2|-2|-1|-1~ig;
	$shadowDir =~ s~left~0|-3|0|-2|0|-1~ig;
	$shadowDir =~ s~right~0|3|0|2|0|1~ig;
	$shadowDir =~ s~top~-3|0|-2|0|-1|0~ig;
	$shadowDir =~ s~bottom~3|0|2|0|1|0~ig;
	return $shadowDir;
}

sub makeShadow {
	$shadColorstr = &convColor($_[1], 3);
	my @shadowColor = split(/\|/, $shadColorstr);
	&decode_direction($_[2]);
	$theText = $_[0];
	$orgText = $_[0];
	@shadowDir = split(/\|/, $shadowDir);
	$theText = &killColor;
	$z = 0; $x = 1;
	$shadowEnh = "px";
	$shadowText = "";
	$shadowText = qq~<div style="position: relative; left: 5px; width: 95%; margin-top: 5px; margin-bottom: 5px;">~;
	for($i = 0; $i < 3; $i++) {
		$shadowText .= qq~<span style="position: absolute; top: $shadowDir[$z]$shadowEnh; left: $shadowDir[$x]$shadowEnh; float: left; width: 100%; color: $shadowColor[$i];">$theText</span>~;
		$z += 2; $x += 2;
	}
	$shadowText .= qq~<span style="position: absolute; top: 0px; left: 0px; float: left; width: $shadowWidth;">$orgText</span>~;
	$shadowText .= qq~$theText</div>~;
	return "$shadowText";
}

</add before>

<search for>
	$message =~ s~\[move\](.*?)\[/move\]~<marquee>$1</marquee>~isg;
</search for>

<add after>

	$message =~ s~\[shadow=(\w+?),(\D\S+?)\](.+?)\[/shadow\]~&makeShadow($3,$1,$2)~eisg;
	$message =~ s~\[glow=(\w+?),\s*?(\d+)\](.+?)\[/glow\]~&makeGlow($3,$1,$2)~eisg;
</add after>


<edit file>
Sources/ubbc.js
</edit file>

<search for>
		document.postmodify.message.setSelectionRange(selectionStart + bbopen.length, selectionEnd + bbopen.length);
	}
	else document.postmodify.message.value += bbopen + bbclose;
</search for>

<add after>
	storeKeypressed();
</add after>

<search for>
		document.postmodify.message.setSelectionRange(selectionStart + markString.length, selectionEnd + bbopen.length);
	}
	else document.postmodify.message.value += bbopen + bbclose;
</search for>

<add after>
	storeKeypressed();
</add after>

<search for>
function emai1() {
</search for>

<add before>
function initObj() {
	this.i;
	return this;
}

var theObj1 = new initObj();
var theObj2 = new initObj();
theObj1.i = 0;
theObj2.i = 0;
temp_cashe = new Array();
temp_cashe[0] = "";

function storeKeypressed() {
	theObj1.i++;
	temp_cashe[theObj1.i] = document.postmodify.message.value;
}

function UndoRedo(todo) {
	if (todo == 'undo') { if (theObj2.i < theObj1.i) theObj2.i++; }
	else { if(theObj2.i > 1) theObj2.i--; }
	var j = temp_cashe.length;
	j -= theObj2.i;
	if (temp_cashe[j]) document.postmodify.message.value = temp_cashe[j];
	else document.postmodify.message.value = temp_cashe[0];
	document.postmodify.message.focus();
}

function shadow() {
	AddSelText("[shadow=gray,bottomright]","[/shadow]");
}

function glow() {
	AddSelText("[glow=yellow,4]","[/glow]");
}

</add before>
